# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python SDK.  To install the official Python SDK, run the following command:  ```bash pip install humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://humanloop.gitbook.io/humanloop-docs/).

    The version of the OpenAPI document: 4.0.0
    Generated by: https://konfigthis.com
"""

from datetime import datetime, date
import typing
from enum import Enum
from typing_extensions import TypedDict, Literal

from humanloop.type.config_response import ConfigResponse
from humanloop.type.src_external_app_models_v4_project_configs_project_model_config_feedback_stats_response import SrcExternalAppModelsV4ProjectConfigsProjectModelConfigFeedbackStatsResponse

class RequiredGetModelConfigResponse(TypedDict):
    created_at: datetime

    updated_at: datetime

    last_used: datetime

    config: ConfigResponse

class OptionalGetModelConfigResponse(TypedDict, total=False):
    # String ID of project the model config belongs to. Starts with `pr_`.
    project_id: str

    # Name of the project the model config belongs to.
    project_name: str

    # Feedback statistics for the project model config.
    feedback_stats: typing.List[SrcExternalAppModelsV4ProjectConfigsProjectModelConfigFeedbackStatsResponse]

    # Number of datapoints associated with this project model config.
    num_datapoints: int

    # The ID of the experiment the model config has been registered to. Only populated when registering a model config to an experiment.
    experiment_id: str

    # ID of trial to reference in subsequent log calls.
    trial_id: str

class GetModelConfigResponse(RequiredGetModelConfigResponse, OptionalGetModelConfigResponse):
    pass
